#include<bits/stdc++.h>

#define pb push_back
#define fi first
#define se second
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int,int> pii;
typedef pair<ll,ll> pll;
typedef long double ld;

template <typename T> chkmin(T& a,T b){return a>b?a=b,1:0;}
template <typename T> chkmax(T& a,T b){return a<b?a=b,1:0;}

ll readint(){
    ll x=0,f=1; char ch=getchar();
    while(ch<'0'||ch>'9'){if(ch=='-')f=-1;ch=getchar();}
    while(ch>='0'&&ch<='9'){x=x*10+ch-'0';ch=getchar();}
    return x*f;
}

int n,q;
int a[100005];
int cnt[35];

int main(){
    n=readint();
    for(int i=1;i<=n;i++) a[i]=readint();
    for(int i=1;i<=n;i++){
        for(int j=0;j<30;j++){
            if(a[i]>>j&1){
                cnt[j]++;
            }
        }
    }
    q=readint();
    while(q--){
        int op=readint();
        if(op==0){
            int k=readint();
            int res=0;
            for(int i=0;i<30;i++){
                if(cnt[i]>=k) res+=(1<<i);
            }
            printf("%d\n",res);
        }else{
            int k=readint(),x=readint();
            for(int j=0;j<30;j++){
                if(a[k]>>j&1){
                    cnt[j]--;
                }
            }
            a[k]=x;
            for(int j=0;j<30;j++){
                if(a[k]>>j&1){
                    cnt[j]++;
                }
            }
        }
    }
    return 0;
}